/************************************************************************/
/*  t@C  :ctrl.c													*/
/*  H/W			:Pi:Co(SH7125)											*/
/*  쐬      :2012/04/15												*/
/*	쐬		:T.Kusumi												*/
/*	vWFNg:}CN}EXŊyg							*/
/*	W[	:Rg[											*/
/************************************************************************/
#include	"common.h"
#include	"ctrl.h"
/************************************************/
/*	LEDS_					(ctrl_led_on)	*/
/************************************************/
/*	ׂĂLED_B						*/
/************************************************/
void ctrl_led_on(void)
{
	//LEDS_
	drv_led_r(LED_ON);				//E_
	drv_led_fr(LED_ON);				//OE_
	drv_led_fl(LED_ON);				//O_
	drv_led_l(LED_ON);				//_
}

/************************************************/
/*	LEDS					(ctrl_led_off)	*/
/************************************************/
/*	ׂĂLEDB						*/
/************************************************/
void ctrl_led_off(void)
{
	//LEDS
	drv_led_r(LED_OFF);				//E
	drv_led_fr(LED_OFF);			//OE
	drv_led_fl(LED_OFF);			//O
	drv_led_l(LED_OFF);				//
}

/************************************************/
/*	ELED					(ctrl_led_r)	*/
/************************************************/
/*	ELED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_r(int i_stat)
{
	//LEDiEj
	drv_led_r(i_stat);
}

/************************************************/
/*	LED					(ctrl_led_l)	*/
/************************************************/
/*	LED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_l(int i_stat)
{
	//LEDij
	drv_led_l(i_stat);
}

/************************************************/
/*	OELED					(ctrl_led_fr)	*/
/************************************************/
/*	OELED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_fr(int i_stat)
{
	//LEDiOEj
	drv_led_fr(i_stat);
}

/************************************************/
/*	OLED					(ctrl_led_fl)	*/
/************************************************/
/*	OLED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_fl(int i_stat)
{
	//LEDiOj
	drv_led_fl(i_stat);
}

/************************************************/
/*	O2LED					(ctrl_led_f)*/
/************************************************/
/*	O2LED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_f(int i_stat)
{
	//O2LED_
	drv_led_fr(i_stat);
	drv_led_fl(i_stat);
}

/************************************************/
/*	LED2i\				(ctrl_led_num)	*/
/************************************************/
/*	LED2i\B						*/
/*----------------------------------------------*/
/*	IN :int i_number c LEDɕ\鐔l		*/
/************************************************/
void ctrl_led_num(int i_number)
{
	//LED2i\B
	drv_led_r(i_number & 0x0001);			//1BITcE
	drv_led_fr((i_number & 0x0002) >> 1);	//2BITcOE
	drv_led_fl((i_number & 0x0004) >> 2);	//3BITcO
	drv_led_l((i_number & 0x0008) >>3);		//4BITc
}

/************************************************/
/*	XCb`iꊇj		(ctrl_sw_all)	*/
/************************************************/
/*	ׂ̃XCb`̏Ԃ擾ĕԂB		*/
/*----------------------------------------------*/
/*	OUT:unsigned char *o_sw_b c XCb`		*/
/*					             ON:SW_ON(0)	*/
/*		unsigned char *o_sw_y c XCb`		*/
/*					             ON:SW_ON(0)	*/
/*		unsigned char *o_sw_r c ԃXCb`		*/
/*					             ON:SW_ON(0)	*/
/************************************************/
void ctrl_sw_all(unsigned char *o_sw_b,
				 unsigned char *o_sw_y,
				 unsigned char *o_sw_r)
{
	//XCb`iꊇj
	*o_sw_b	= drv_sw_b();			//XCb`
	*o_sw_y	= drv_sw_y();			//XCb`
	*o_sw_r	= drv_sw_r();			//ԃXCb`
	//ǂꂩ̃XCb`ONȂ΁AׂẴXCb`OFFɂȂ܂ő҂B
	if (*o_sw_b == SW_ON || *o_sw_y == SW_ON || *o_sw_r == SW_ON)
	{
		while(drv_sw_b() == SW_ON || drv_sw_y() == SW_ON || drv_sw_r() == SW_ON);
	}
}

/************************************************/
/*	uU[						(ctrl_bz)	*/
/************************************************/
/*	gԂw肵ăuU[炷B		*/
/*----------------------------------------------*/
/*	IN :int i_freq   c g					*/
/*		int	i_ms     c (ms)				*/
/************************************************/
void ctrl_bz(int i_freq, int i_ms)
{
	//uU[
	drv_bz(i_freq, i_ms);				//炷
}

/************************************************/
/*	uU[ifBj	(ctrl_bz_melody)	*/
/************************************************/
/*	ge|w肵ăuU[炷B*/
/*	Ė炷ꍇɉȂȂ悤	*/
/*	ZԂ̊ԊuB						*/
/*----------------------------------------------*/
/*	IN :int i_freq  c g					*/
/*		int i_beat  c (l=2)			*/
/*		int i_tempo c e|(1Ԃ̔)		*/
/************************************************/
void ctrl_bz_melody(int i_freq, int i_beat, int i_tempo)
{
	//uU[ifBj
	int ms = (i_beat * 60 * 1000 / 2) / i_tempo;
	//
	drv_bz(i_freq, (int)(ms * 0.9));			//炷
	drv_bz(BZ_FREQ_REST, (int)(ms * 0.1));		//Ԋu
}

/************************************************/
/*	A/DϊiEZTj		(ctrl_adc_r)	*/
/************************************************/
/*	EZT̒l擾B					*/
/*----------------------------------------------*/
/*	RET:int			c ZTl					*/
/************************************************/
int ctrl_adc_r(void)
{
	//A/DϊiEZTj
	int	value;
	//EZT̒l擾
	value = drv_adc_r();
	//
	return value;
}

/************************************************/
/*	A/DϊiZTj		(ctrl_adc_l)	*/
/************************************************/
/*	ZT̒l擾B					*/
/*----------------------------------------------*/
/*	RET:int			c ZTl					*/
/************************************************/
int ctrl_adc_l(void)
{
	//A/DϊiZTj
	int	value;
	//ZT̒l擾
	value = drv_adc_l();
	//
	return value;
}

/************************************************/
/*	A/DϊiOEZTj	(ctrl_adc_fr)	*/
/************************************************/
/*	OEZT̒l擾B					*/
/*----------------------------------------------*/
/*	RET:int			c ZTl					*/
/************************************************/
int ctrl_adc_fr(void)
{
	//A/DϊiOEZTj
	int	value;
	//OEZT̒l擾
	value = drv_adc_fr();
	//
	return value;
}

/************************************************/
/*	A/DϊiOZTj	(ctrl_adc_fl)	*/
/************************************************/
/*	OZT̒l擾B					*/
/*----------------------------------------------*/
/*	RET:int			c ZTl					*/
/************************************************/
int ctrl_adc_fl(void)
{
	//A/DϊiOZTj
	int	value;
	//OZT̒l擾
	value = drv_adc_fl();
	//
	return value;
}

/************************************************/
/*	ʐMiAlMj(ctrl_com_send)	*/
/************************************************/
/*	𑗐MB							*/
/*----------------------------------------------*/
/*	IN :char *i_string	c 				*/
/*		int   i_int 	c l					*/
/*	RET:int	c COM_OK ( 0):					*/
/*			   COM_ERR(-1):G[				*/
/************************************************/
int ctrl_com_send(char *i_string, int i_int)
{
	//ʐMiAlMj
	int stat = COM_OK;
	//
	stat = ctrl_com_string(i_string);
	if(stat == COM_OK)
	{
		stat = ctrl_com_int(i_int);
	}
	//
	return stat;
}

/************************************************/
/*	ʐMi񑗐Mj	(ctrl_com_string)	*/
/************************************************/
/*	𑗐MB							*/
/*----------------------------------------------*/
/*	IN :char *i_string c 				*/
/*	RET:int	c COM_OK ( 0):					*/
/*			   COM_ERR(-1):G[				*/
/************************************************/
int ctrl_com_string(char *i_string)
{
	//ʐMi񑗐Mj
	int i;
	int stat = COM_OK;
	//
	for(i = 0; i < 1024; i++)
	{
		if(*i_string == 0)
		{
			//\0ŏI
			break;
		}
		stat = drv_com_send(*i_string);		//1M
		if(stat == COM_ERR)
		{
			break;
		}
		i_string++;
	}
	return stat;
}

/************************************************/
/*	ʐMilMj		(ctrl_com_int)	*/
/************************************************/
/*	int𕶎ɕϊđMB				*/
/*----------------------------------------------*/
/*	IN :int i_int c l						*/
/*	RET:int	c COM_OK ( 0):					*/
/*			   COM_ERR(-1):G[				*/
/************************************************/
int ctrl_com_int(int i_int)
{
	//ʐMilMj
	int i;
	int stat = COM_OK;
	char buf[6];
	int sign;
	char numStr[10] = "0123456789";
	//
	if(i_int < 0)
	{
		sign = -1;
	}
	else
	{
		sign = 1;
	}
	i_int = i_int * sign;
	//
	if(sign >= 0)
	{
		buf[0] = ' ';
	}
	else
	{
		buf[0] = '-';
	}
	buf[1] = numStr[(int)(i_int / 10000)];
	buf[2] = numStr[(int)((i_int % 10000) / 1000)];
	buf[3] = numStr[(int)((i_int % 1000) / 100)];
	buf[4] = numStr[(int)((i_int % 100) / 10)];
	buf[5] = numStr[(int)(i_int % 10)];
	//
	for(i = 0; i < 6; i++)
	{
		stat = drv_com_send(buf[i]);		//1M
		if(stat == COM_ERR)
		{
			break;
		}
	}
	//
	return stat;
}
