/************************************************************************/
/*  t@C  :drv.c													*/
/*  H/W			:Pi:Co(SH7125)											*/
/*  쐬      :2012/04/15												*/
/*	쐬		:T.Kusumi												*/
/*	vWFNg:}CN}EXŊyg							*/
/*	W[	:hCo												*/
/************************************************************************/
#include	"iodefine.h"
#include	"common.h"
#include	"drv.h"

/************************************************/
/*	LEDhCoiEj			(drv_led_r)		*/
/************************************************/
/*	ELED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void drv_led_r(int i_stat)
{
	//LEDhCoiEj
	LED_R = i_stat;
}

/************************************************/
/*	LEDhCoij			(drv_led_l)		*/
/************************************************/
/*	LED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void drv_led_l(int i_stat)
{
	//LEDhCoij
	LED_L = i_stat;
}

/************************************************/
/*	LEDhCoiOEj			(drv_led_fr)	*/
/************************************************/
/*	OELED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void drv_led_fr(int i_stat)
{
	//LEDhCoiOEj
	LED_FR = i_stat;
}

/************************************************/
/*	LEDhCoiOj			(drv_led_fl)	*/
/************************************************/
/*	OLED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void drv_led_fl(int i_stat)
{
	//LEDhCoiOj
	LED_FL = i_stat;
}

/************************************************/
/*	XCb`hCoij			(drv_sw_b)	*/
/************************************************/
/*	XCb`̏ԂǂŕԂB				*/
/*----------------------------------------------*/
/*	RET:unsiged char	c XCb`̏		*/
/*					       ON:SW_ON(0)			*/
/************************************************/
unsigned char drv_sw_b(void)
{
	//XCb`hCoij
	drv_wait_ms(CHAT_WAIT);		//`^Oh~̂WAIT
	//XCb`ǂݍ
	return SW_BLUE;
}

/************************************************/
/*	XCb`hCoij			(drv_sw_y)	*/
/************************************************/
/*	XCb`̏ԂǂŕԂB				*/
/*----------------------------------------------*/
/*	RET:unsiged char	c XCb`̏		*/
/*					       ON:SW_ON(0)			*/
/************************************************/
unsigned char drv_sw_y(void)
{
	//XCb`hCoij
	drv_wait_ms(CHAT_WAIT);		//`^Oh~̂WAIT
	//XCb`ǂݍ
	return SW_YELLOW;
}

/************************************************/
/*	XCb`hCoiԁj			(drv_sw_r)	*/
/************************************************/
/*	ԃXCb`̏ԂǂŕԂB				*/
/*----------------------------------------------*/
/*	RET:unsiged char	c ԃXCb`̏		*/
/*					       ON:SW_ON(0)			*/
/************************************************/
unsigned char drv_sw_r(void)
{
	//XCb`hCoiԁj
	drv_wait_ms(CHAT_WAIT);		//`^Oh~̂WAIT
	//XCb`ǂݍ
	return SW_RED;
}

/************************************************/
/*	uU[hCo				(drv_bz)		*/
/************************************************/
/*	gA(ms)w肵ăuU[炷B	*/
/*----------------------------------------------*/
/*	IN :int   i_freq   c g				*/
/*		int	  i_ms     c (ms)				*/
/************************************************/
void drv_bz(int i_freq, int i_ms)
{
	//uU[hCo
	float cycle;
	float pulsWidth;
	//
	if (i_freq == 0)
	{
		//Wait
		drv_wait_ms(i_ms);
	}
	else
	{
		//gݒ
		cycle = (float)MTU_BZ_CLOCK / (float)i_freq;
		pulsWidth = cycle / 2.0;
		MTU_BZ_CYCLE = (short)cycle;
		MTU_BZ_PULSWIDTH = (short)pulsWidth;
		//U
		MTU22.TCNT = 0;
		MTU_BZ = BZ_ON;			//uU[̔UJn
		drv_wait_ms(i_ms);		//w莞 ҂
		MTU_BZ = BZ_OFF;		//uU[̔UI
	}
}

/************************************************/
/*	A/DϊhCoiEZT[j	(drv_adc_r)	*/
/************************************************/
/*	EZT[pLEDONɂAl		*/
/*	A/DϊĎ擾ĕԂB					*/
/*----------------------------------------------*/
/*	RET:int c li6BIT͎̂Ăj	*/
/************************************************/
int drv_adc_r(void)
{
	//A/DϊhCoiEZT[j
	int i;
	//
	SLED_R = LED_ON;						//LED_
	//
	ADC_R_CH = ADC_R_CHNO;					//ADϊ̃`lI
	//
	for(i = 0; i < ADC_WAIT_COUNT; i++);	//tHggWX^̉҂[v
	ADC_R_START = 1;						//ADϊJn
	//
	while(ADC_R_FIN_FLG == 0);				//ADϊI܂ő҂
	ADC_R_FIN_FLG = 0;						//tONA
	//
	SLED_R = LED_OFF;						//LED
	//
	return ADC_R_VALUE >> 6;				//lԂ
}

/************************************************/
/*	A/DϊhCoiZT[j	(drv_adc_l)	*/
/************************************************/
/*	ZT[pLEDONɂAl		*/
/*	A/DϊĎ擾ĕԂB					*/
/*----------------------------------------------*/
/*	RET:int c li6BIT͎̂Ăj	*/
/************************************************/
int drv_adc_l(void)
{
	//A/DϊhCoiZT[j
	int i;
	//
	SLED_L = LED_ON;						//LED_
	//
	ADC_L_CH = ADC_L_CHNO;					//ADϊ̃`lI
	//
	for(i = 0; i < ADC_WAIT_COUNT; i++);	//tHggWX^̉҂[v
	ADC_L_START = 1;						//ADϊJn
	//
	while(ADC_L_FIN_FLG == 0);				//ADϊI܂ő҂
	ADC_L_FIN_FLG = 0;						//tONA
	//
	SLED_L = LED_OFF;						//LED
	//
	return ADC_L_VALUE >> 6;				//lԂ
}

/************************************************/
/*	A/DϊhCoiOEZT[j	(drv_adc_fr)*/
/************************************************/
/*	OEZT[pLEDONɂAl		*/
/*	A/DϊĎ擾ĕԂB					*/
/*----------------------------------------------*/
/*	RET:int c li6BIT͎̂Ăj	*/
/************************************************/
int drv_adc_fr(void)
{
	//A/DϊhCoiOEZT[j
	int i;
	//
	SLED_FR = LED_ON;						//LED_
	//
	ADC_FR_CH = ADC_FR_CHNO;				//ADϊ̃`lI
	//
	for(i = 0; i < ADC_WAIT_COUNT; i++);	//tHggWX^̉҂[v
	ADC_FR_START = 1;						//ADϊJn
	//
	while(ADC_FR_FIN_FLG == 0);				//ADϊI܂ő҂
	ADC_FR_FIN_FLG = 0;						//tONA
	//
	SLED_FR = LED_OFF;						//LED
	//
	return ADC_FR_VALUE >> 6;				//lԂ
}

/************************************************/
/*	A/DϊhCoiOZT[j	(drv_adc_fl)*/
/************************************************/
/*	OZT[pLEDONɂAl		*/
/*	A/DϊĎ擾ĕԂB					*/
/*----------------------------------------------*/
/*	RET:int c li6BIT͎̂Ăj	*/
/************************************************/
int drv_adc_fl(void)
{
	//A/DϊhCoiOZT[j
	int i;
	//
	SLED_FL = LED_ON;						//LED_
	//
	ADC_FL_CH = ADC_FL_CHNO;				//ADϊ̃`lI
	//
	for(i = 0; i < ADC_WAIT_COUNT; i++);	//tHggWX^̉҂[v
	ADC_FL_START = 1;						//ADϊJn
	//
	while(ADC_FL_FIN_FLG == 0);				//ADϊI܂ő҂
	ADC_FL_FIN_FLG = 0;						//tONA
	//
	SLED_FL = LED_OFF;						//LED
	//
	return ADC_FL_VALUE >> 6;				//lԂ
}

/************************************************/
/*	ʐMhCoi1Mj	(drv_com_send)	*/
/************************************************/
/*	1MB								*/
/*----------------------------------------------*/
/*	IN :char i_char c M镶				*/
/*	RET:int			c ʐMXe[^X			*/
/*						COM_OK ( 0):		*/
/*						COM_ERR(-1):G[		*/
/************************************************/
int drv_com_send(char i_char)
{
	//ʐMhCoi1Mj
	int i;
	//
	for(i = 0; i < COM_TO_COUNT; i++)
	{
		if(COM_SEND_FLG)					//tOmF
		{
			COM_SEND_DATA = i_char;			//Mf[^
			COM_SEND_FLG = 0;				//tONA
			return COM_OK;
		}
	}
	return COM_ERR;							//^CAEg
}

/************************************************/
/*	EFCg					(drv_wait_ms)	*/
/************************************************/
/*	msPʂő҂Ԃ𐶐B				*/
/*----------------------------------------------*/
/*	IN :int i_ms c ҂(ms)				*/
/************************************************/
void drv_wait_ms(int i_ms)
{
	//msPʂő҂Ԃ𐶐B
	int startCount;
	//
	startCount = G_TimerCount;
	//
	while((G_TimerCount - startCount) < i_ms);
}

